'''
Created on 06/02/2012

@author: antony phillips

Amalgamates all *.patch files into a single file (fullpatch)
  Also will change the path stems, and will omit patches with given banned text in the file name
'''

from glob import glob
import sys

def patchStart(lines):
    """ Returns True if the first line is the start of a new (sub)patch """
    return (lines[0].find("Index: ") == 0) and (lines[1].find("="*67) == 0)

#inputs
pathStemChange = ("C:/COIN/Dip/", sys.argv[1]) #from, to
bannedText = "MSVisualStudio"
outputName = "linuxpatch"
#/inputs

print "Amalgamating Patches into: %s"%outputName
print " Changing DIP path stem from \"%s\" to \"%s\""%pathStemChange
if bannedText: print " Excluding patches with \"%s\" in pathname"%bannedText

amalFp = open(outputName, "w")

for filename in glob('*.patch'):
    print "  Adding patch: %s"%filename
    fp  = open(filename, 'r')
    lines = fp.readlines()
    fp.close()
    
    writing = False
    for i,l in enumerate(lines):
        if (i <= len(lines) - 2) and patchStart(lines[i:i+2]): # check if this line is start of (sub)patch
            writing = (not bannedText) or (l.find(bannedText) == -1) # writing is on if there is no bannedText, or if it is not found in the title
        
        if writing:
            amalFp.write(l.replace(pathStemChange[0], pathStemChange[1]))

amalFp.close()
print "Output written to: %s"%outputName
